/*
	Bishop Fox - Theos for jailed iOS devices
*/
#import <dlfcn.h>
#include <pthread.h>
#include <errno.h>
#include <objc/message.h>
#import "Cycript.framework/headers/cycript.h"
#include "fishhook/fishhook.h"
#include "iSpy.class.h"
#include "iSpy.common.h"
#include "iSpy.instance.h"
#include "iSpy.msgSend.common.h"

#define CYCRIPT_PORT 31337

/*
 * Constructor
 */
%ctor {
	NSLog(@"[BF] Constructor entry");
	
	// initialize and cache the iSpy sharedInstance. 
	NSLog(@"[BF] Activating iSpy");
	[iSpy sharedInstance]; // do nothing with the return value, just force iSpy to initialize
	
	// Start Cycript
	ispy_nslog("[BF] Starting Cycript. Connect by running \"cycript -r <yourIOSDeviceIP>:%d\" on your MacBook.", CYCRIPT_PORT);
	CYListenServer(CYCRIPT_PORT);

    /* 
     *	The objc_msgSend tracing feature uses a whitelist to determine which methods/classes
     *	should be monitored and logged. By default the whitelist contains all of the methods in all 
     *	of the the classes defined by the target app. 
     *	You can add/remove individual methods and/or entire classes to/from the whitelist.
     *	This is good for removing animations, CPU hogs, and other uninteresting crap.
     */
    //ispy_nslog("[BF] Removing unwanted classes from msgSend whitelist");
    //[mySpy msgSend_whitelistRemoveClass:@"ClassWeDoNotCareAbout"];

    // Remove an individual method from the whitelist
    //[mySpy msgSend_whitelistRemoveMethod:@"testMethod" fromClass:@"FooClass"];

    // Add a method to the whitelist
    //[mySpy msgSend_whitelistAddMethod:@"setHTTPBody:" forClass:@"NSMutableURLRequest"];

    // Add all the methods in a single class
	//[mySpy msgSend_whitelistAddClass:@"NSURLConnection"];
	    
	/*
	 *	Turn on objc_msgSend tracing.
	 *	You can also turn it on/off in Cycript using: 
	 *		[[iSpy sharedInstance] msgSend_enableLogging]
	 *		[[iSpy sharedInstance] msgSend_disableLogging]
	 */
	//ispy_nslog("[BF] Enabling msgSend logging to %s/Documents/.iSpy/*.log", [[mySpy appPath] UTF8String]);
	//[mySpy msgSend_enableLogging];

	/*
	 *	Bypass SSL pinning. Uses a combination of:
	 *		- TrustMe SecTrustEvaluate() bypass
	 *		- BF's custom AFNetworking bypasses
	 *	This is disabled by default and you must enable it manually here or
	 *	in Cycript, by using: [[iSpy sharedInstance] SSLPinning_enableBypass]
	 */
	//ispy_nslog("[BF] Enabling SSL Pinning bypasses");
	//[mySpy SSLPinning_enableBypass];
	
	/*
	 *	By default the instance tracker is off. Turn it on.
	 */
	ispy_nslog("[BF] Enabling instance tracker");
	[[[iSpy sharedInstance] instanceTracker] start];
	
	/*
	 *	Now we continue with the normal load process, passing control to the app's main() function.
	 */
	ispy_nslog("[BF] All done, continuing dyld load sequence.");
}
